/*
**> In this program, we compute the local volatility from the implied volatility
** 
*/

new;
library option,pgraph;
OptionSet;

loadm databuf = dupire-ImpVol;

Smile_K = vread(databuf,"K");
Smile_T = vread(databuf,"T");
Smile_ImpVol = vread(databuf,"ImpVol");

S0 = 100;
b = 0.05;
r = 0.05;

K = seqa(0,1,201);
t = seqa(0,10/250,75);

// Saves all the information into dupire9*.dat filenames
call ImpVol_to_LocalVol_CSGI(Smile_K,Smile_ImpVol,Smile_T,T,K,S0,b,r,"dupire9");
LocalVol1 = loadd("dupire9-localvol");

// Saves the local volatility into a matrix
LocalVol2 = ImpVol_to_LocalVol_CSGI(Smile_K,Smile_ImpVol,Smile_T,T,K,S0,b,r,0);

graphset;
  _pnum = 2; _pframe = 0; _pdate = "";
  fonts("simplex simgrma");
  xlabel("\216K");
  xtics(0,200,50,2);
  ylabel("\216\202t\201");
  ytics(0,2,0.5,2);
  surface(K',t,LocalVol2);

