/*
**> Example to show how to extract the right information for the simulated paths
**
*/

new;
library option,pgraph;

cls;

let x0 = 100 50 75;            
let mu = 0.05 0.07 0.08;
let sigma = 0.15 0.25 0.05;

let rho = {1,
           0.5, 1,
           0.25, 0.15, 1};

rho = xpnd(rho);

t = seqa(0.25,0.25,8);

Ns = 10000;
x = array_simulate_mGBM(x0,mu,sigma,rho,t,Ns);

t0 = 2;

z = mGBM_getDate(t,x,t0);
m = x0 .* exp(mu*t0);
v = x0^2 .* exp(2*mu*t0) .* (exp(sigma^2 * t0) - 1.0);
print "Test of the mean and volatility:";
print "--------------------------------";
(meanc(z)~stdc(z))./(m~sqrt(v));
print;

z = ln(mGBM_getDate(t,x,t0));
m = ln(x0) + (mu-0.5*sigma^2)*t0;
v = sigma^2 * t0;
print "Test of the mean and volatility:";
print "--------------------------------";
(meanc(z)~stdc(z))./(m~sqrt(v));
print;

print "----------------------------------------------------------------------";
print "Extracts a date:";
z = mGBM_getDate(t,x,t[rows(t)]);
print z[50,.];;
print x[rows(t),50,.];
print;

print "----------------------------------------------------------------------";
print "Extracts an asset:";
z = mGBM_getAsset(x,3);
print z[50,.];;
print atranspose(x[.,50,3],2|3|1);
print;

print "----------------------------------------------------------------------";
print "Extracts a simulation:";
z = mGBM_getSimul(x,50);
print z[.,3]';;
print atranspose(x[.,50,3],2|3|1);
print;