new;
library option,pgraph;

S0 = 100;
K = 100;
sigma = 0.20;
r = 0.05;
b = r;
tau = 3/12;  // 3 Months

fn lookback_payoff(ST,Smin) = (ST - Smin) .* (ST .>= Smin);

t = seqa(0,tau/60,61);
nS = 100000;
S = simulate_GBM(S0,b,sigma,t,nS);
nT = rows(t);
ST = S[nT,.]';
Smin = minc(S);

LBC = exp(-r*tau)*meanc(lookback_payoff(ST,Smin));

print ftos(LBC,"Look-back call = %lf",6,5);

nS = 100000;
nt = seqa(5,1,96);
LBC = zeros(rows(nt),1);

i = 1;
do until i > rows(nt);
  t = seqa(0,tau/(nt[i]-1),nt[i]);
  S = simulate_GBM(S0,b,sigma,t,nS);
  ST = S[nt[i],.]';
  Smin = minc(S);
  LBC[i] = exp(-r*tau)*meanc(lookback_payoff(ST,Smin));
  print /flush i;
  i = i + 1;
endo;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 3; _plwidth = 10; _pcolor = 12;
  xlabel("\216Number of discretization points");
  xtics(0,100,10,2);
  graphprt("-c=1 -cf=mc2.eps");
  xy(nt,lbc);
 

