/*
**> An example to show how the actual smile moves
** with respect to the Forward
**
*/

new;

#ifdef USE_OPTMUM
  library option,pgraph,optmum;
#else
  library option,pgraph;
#endif

optionSet;

cls;

F0 = 0.05;
tau = 1;

let Strike = 0.04 0.05 0.08;
let ImpVol = 0.11 0.09 0.10;

ATM = ImpVol[2];

beta = 0;
{alpha1,beta1,nu1,rho1} = SABR_Calibrate(F0,Strike,ImpVol,beta,tau,0);

beta = 0.5;
{alpha2,beta2,nu2,rho2} = SABR_Calibrate(F0,Strike,ImpVol,beta,tau,0);

beta = 1;
{alpha3,beta3,nu3,rho3} = SABR_Calibrate(F0,Strike,ImpVol,beta,tau,0);

N = 81;
K = seqa(0.02,0.001,N);
Smile1 = SABR_ImpVol_ATM(F0,K,ATM,beta1,nu1,rho1,tau);
Smile2 = SABR_ImpVol_ATM(F0,K,ATM,beta2,nu2,rho2,tau);
Smile3 = SABR_ImpVol_ATM(F0,K,ATM,beta3,nu3,rho3,tau);
Smile = Smile1~Smile2~Smile3;

F0 = 0.055;

Smile1 = SABR_ImpVol_ATM(F0,K,ATM,beta1,nu1,rho1,tau);
Smile2 = SABR_ImpVol_ATM(F0,K,ATM,beta2,nu2,rho2,tau);
Smile3 = SABR_ImpVol_ATM(F0,K,ATM,beta3,nu3,rho3,tau);
Smile_Future_1 = Smile1~Smile2~Smile3;

F0 = 0.045;

Smile1 = SABR_ImpVol_ATM(F0,K,ATM,beta1,nu1,rho1,tau);
Smile2 = SABR_ImpVol_ATM(F0,K,ATM,beta2,nu2,rho2,tau);
Smile3 = SABR_ImpVol_ATM(F0,K,ATM,beta3,nu3,rho3,tau);
Smile_Future_2 = Smile1~Smile2~Smile3;

graphset;
  begwind;
  makewind(9/2,6.855/2,0,6.855/2,1);
  makewind(9/2,6.855/2,9/2,6.855/2,1);
  makewind(9/2,6.855/2,9/4,0,1);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.22; _pnumht = 0.20; _ptitlht = 0.22;
  _pltype = 6|1|3;
  _plwidth = 10;
  ylabel("\216Black Volatility (%)");
  xlabel("\216Strike (%)"); 
  xtics(0,10,2,2);
  ytics(8,14,1,2);
  _psym = 100*Strike~100*ImpVol~ones(rows(ImpVol),1).*(11~8~0~1~0);
  _plegstr = "\202b\201 = 0\000\202b\201 = 0.5\000\202b\201 = 1";

  setwind(1);
    title("\216Today Smile");
    xy(100*K,100*Smile);

  setwind(2);
    title("\216Future Smile (Forward: 5% --> 5.5%)");
    xy(100*K,100*Smile_Future_1);

  setwind(3);
    title("\216Future Smile (Forward: 5% --> 4.5%)");
    _plegctl = {2 6 6 4.0};
    xy(100*K,100*Smile_Future_2);

  endwind;





