/*
**> Durrleman Approximation of the Heston Model
**
*/

new;
library option,pgraph;

// #define VD_OLD_VERSION

S0 = 100;
r = 0.0;

kappa = 1;
sigma = 0.20;
mu = sigma^2;
epsilon = 0.2;
rho = -0.75~-0.50~-0.25~0~0.25;

K = seqa(80,1,41);

_VD_order = 4;

tau = 1/12;
Smile1 = VD_HestonSmile(S0,K,sigma,kappa,mu,epsilon,rho,tau,r);

tau = 6/12;
Smile2 = VD_HestonSmile(S0,K,sigma,kappa,mu,epsilon,rho,tau,r);

tau = 12/12;
Smile3 = VD_HestonSmile(S0,K,sigma,kappa,mu,epsilon,rho,tau,r);

tau = 2;
Smile4 = VD_HestonSmile(S0,K,sigma,kappa,mu,epsilon,rho,tau,r);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");

  _pltype = 6|3|1; _pframe = 0; _pnum = 2;
  _paxht = 0.18; _pnumht = 0.18; _pcolor = 9|10|11|12|13;
  _plwidth = 10; _ptitlht = 0.22;

  xtics(80,120,10,2);
  ytics(0.16,0.24,0.02,2);

  setwind(1);
    title("\216T = 1M");
    xy(K,smile1);

  setwind(2);
    title("\216T = 6M");
    xy(K,smile2);

  setwind(3);
    title("\216T = 1Y");
    xy(K,smile3);

  ytics(0.16,0.20,0.02,2);

  setwind(4);
    title("\216T = 2Y");
    _plegstr = "\202r\201 = -0.75\000\202r\201 = -0.50\000\202r\201 = -0.25\000\202r\201 = 0\000\202r\201 = 0.25";
    _plegctl = {2 5 1.5 0.75};
    xy(K,smile4);
 
  endwind;