new;

#define USE_QNEWTON

#ifdef USE_CO
  library option,co,pgraph;
#endif

#ifdef USE_OPTMUM
  library option,optmum,pgraph;
#endif

#ifdef USE_QNEWTON
  library option,pgraph;
#endif

// #define VD_OLD_VERSION 1.0

cls;

_VD_order = 4;

S0 = 100;
tau = 1/2;
r = 0.0;

kappa = 1;
sigma = 0.20;
mu = sigma^2;
epsilon = 0.2;
rho = -0.3;

fn SmileProc(K) = VD_HestonSmile(S0,K,sigma,kappa,mu,epsilon,rho,tau,r);
K = 90|95|100|105|110;

MarketSmile = SmileProc(K);

#ifdef VD_OLD_VERSION

proc (6) = ModelParams(theta);
  theta[1:4] = sqrt(theta[1:4]^2);
  retp(VD_Heston_Parameters(theta[1],theta[2],theta[3],theta[4],theta[5]));
endp;

#else

proc (9) = ModelParams(theta);
  theta[1:4] = sqrt(theta[1:4]^2);
  retp(VD_Heston_Parameters(theta[1],theta[2],theta[3],theta[4],theta[5]));
endp;

#endif


_co_Algorithm = 1;
__output = 1;

sv = 0.22|1|0.1^2|0.2|-0.1;
{theta,fmin,grd,retcode} = VD_Calibraton(S0,K,MarketSmile,tau,&ModelParams,sv,0);
theta[1:4] = sqrt(theta[1:4]^2);

x = seqa(70,1,61);

Smile1 = VD_HestonSmile(S0,x,sigma,kappa,mu,epsilon,rho,tau,r);
Smile2 = VD_HestonSmile(S0,x,theta[1],theta[2],theta[3],theta[4],theta[5],tau,r);

graphset;
  _pdate = "";
  _pltype = 6|3|1; _pframe = 0; _pnum = 2; _plwidth = 10;
  _pcolor = 10|13;
  xlabel("\216K");
  ytics(0.18,0.23,0.01,2);
  title("\216Smile");
  e = ones(rows(K),1);
  _psym = K~MarketSmile~e.*(11~5~12~1~10);
  _plegstr = "Heston\000Durrleman";
  _plegctl = {2 5 5 4};
  graphprt("-c=1 -cf=smile_to_density4.eps");
  xy(x,smile1~smile2);
